/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 844
#ifdef HAVE_CONFIG_H
#line 844
# include <config.h>
#line 844
#endif
#line 844
#include <sys/types.h>
#line 844

#line 844
#include "mailfromd.h"
#line 844
#include "prog.h"
#line 844
#include "builtin.h"
#line 844

#line 151 "db.bi"
static mu_debug_handle_t debug_handle;
#line 844 "db.bi"

#line 742 "../../src/builtin/snarf.m4"

#line 1 "db.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#define DEFAULT_DB_MODE 0640
#include <fnmatch.h>
#include "mf-dbm.h"

struct db_prop {                /* Database properties */
	char *pat;              /* Database name pattern */
	mode_t mode;            /* File mode */
	int null;               /* Null byte */
};

static mu_list_t db_prop_list;

static int
db_prop_compare(const void *item, const void *data)
{
	const struct db_prop *prop = item;
	const char *name = data;
	return strcmp(prop->pat, name);
}

static int
strtomode(char *str, mode_t *pmode)
{
	mode_t mode = 0;
	struct { char c; unsigned mask; } modetab[] = {
		{ 'r', S_IRUSR },
		{ 'w', S_IWUSR },
		{ 'x', S_IXUSR },
		{ 'r', S_IRGRP },
		{ 'w', S_IWGRP },
		{ 'x', S_IXGRP },
		{ 'r', S_IROTH },
		{ 'w', S_IWOTH },
		{ 'x', S_IXOTH },
		{ 0 }
	};
	int i;

	for (i = 0; modetab[i].c; i++) {
		if (!str[i])
			return i + 1;
		if (str[i] == modetab[i].c)
			mode |= modetab[i].mask;
		else if (str[i] != '-')
			return i + 1;
	}
	if (str[i])
		return i + 1;
	*pmode = mode;
	return 0;
}

/* #pragma dbprop <name> [null] [mode] */
#line 70 "db.bi"

#line 70
static void _pragma_dbprop (int argc, char **argv, const char *text)
#line 70

{
	int null = 0;
	mode_t mode = DEFAULT_DB_MODE;
	struct db_prop *prop;
	int rc;
	char *pat;

	--argc;
	pat = *++argv;
	
	while (--argc) {
		char *p = *++argv;

		if (strcmp(p, "null") == 0)
			null = 1;
		else if (c_isdigit(*p)) {
			unsigned long n = strtoul(p, &p, 8);
			if (*p || (mode = n) != n) {
				parse_error(_("bad numeric file mode"));
				return;
			}
		} else if (rc = strtomode(p, &mode)) {
			parse_error(_("bad symbolic file mode (near %s)"),
				    p + rc - 1);
			return;
		}
	}

	if (!db_prop_list) {
		rc = mu_list_create(&db_prop_list);
		if (rc) {
			parse_error(_("cannot create list: %s"),
				    mu_strerror(rc));
			return;
		}
		mu_list_set_comparator(db_prop_list, db_prop_compare);
	}

	if (mu_list_locate(db_prop_list, pat, (void**) &prop)) {
		prop = xmalloc(sizeof(*prop));
		prop->pat = xstrdup(pat);
		rc = mu_list_append(db_prop_list, prop);
		if (rc) {
			parse_error(_("Cannot create list: %s"),
				    mu_strerror(rc));
			return;
		}
	}
	prop->mode = mode;
	prop->null = null;
}

const struct db_prop *
db_prop_lookup(const char *name)
{
	mu_iterator_t itr;
	const struct db_prop *found = NULL;
	
	if (db_prop_list
	    && mu_list_get_iterator(db_prop_list, &itr) == 0) {
		for (mu_iterator_first(itr);
		     !mu_iterator_is_done(itr);
		     mu_iterator_next(itr)) {
			const struct db_prop *p;
			mu_iterator_current(itr, (void**)&p);
			if (strcmp(p->pat, name) == 0) {
				found = p;
				break;
			} else if (fnmatch(p->pat, name, 0) == 0)
				found = p;
		}
		mu_iterator_destroy(&itr);
	}
	return found;	
}


#define LOOKUP_NULL_BYTE 0x1
#define LOOKUP_TEST_ONLY 0x2


#line 151

#line 151
static int
#line 151
dbmap_lookup(eval_environ_t env, char *dbname, const char *keystr,
#line 151
	     const char *defval, int flags)
#line 151
{
#line 151
	int rc;
#line 151
	MF_DBM_FILE db;
#line 151
	MF_DBM_DATUM key;
#line 151
	MF_DBM_DATUM contents;
#line 151

#line 151
	if (!defval)
#line 151
		defval = "";
#line 151
	if (mf_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
#line 151
		(
#line 151
	env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror())
#line 151
);
#line 151

#line 151
	memset(&key, 0, sizeof key);
#line 151
	memset(&contents, 0, sizeof contents);
#line 151
	MF_DATUM_PTR(key) = (void*) keystr;
#line 151
	MF_DATUM_SIZE(key) = strlen(keystr);
#line 151
	if (flags & LOOKUP_NULL_BYTE)
#line 151
		MF_DATUM_SIZE(key)++;
#line 151
	rc = mf_dbm_fetch(&db, key, &contents) == 0;
#line 151
	
#line 151 "db.bi"

#line 151
mu_debug(debug_handle, MU_DEBUG_TRACE5,("Looking up %s: %s", keystr, rc ? "true" : "false"));
#line 151
	if (flags & LOOKUP_TEST_ONLY) 
#line 151
		push(env, (STKVAL)rc);
#line 151
	else {
#line 151
		if (!rc) {
#line 151
			if (defval)
#line 151
				pushs(env, (STKVAL)defval);
#line 151
			else
#line 151
				push(env, 0);
#line 151
		} else if (((char*)MF_DATUM_PTR(contents))[MF_DATUM_SIZE(contents)-1]) {
#line 151
			size_t off;
#line 151
			size_t len = MF_DATUM_SIZE(contents);
#line 151
			char *s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
#line 151
			memcpy(s, MF_DATUM_PTR(contents), len);
#line 151
			s[len] = 0;
#line 151
			push(env, (STKVAL) off);
#line 151
		} else
#line 151
			pushs(env, MF_DATUM_PTR(contents));
#line 151
	}
#line 151
	mf_dbm_datum_free(&contents);
#line 151
	mf_dbm_close(&db);
#line 151
	return rc;
#line 151
}
#line 151

#line 151

#line 151

#line 200



void
#line 203
bi_dbmap(eval_environ_t env)
#line 203

#line 203

#line 203 "db.bi"
{
#line 203
	
#line 203

#line 203
long __bi_argcnt;
#line 203
char * MFL_DATASEG dbname;
#line 203
        char * MFL_DATASEG key;
#line 203
        long  null;
#line 203
        
#line 203
get_string_arg(env, 1, &dbname);
#line 203
        get_string_arg(env, 2, &key);
#line 203
        get_numeric_arg(env, 3, &null);
#line 203
        
#line 203
get_numeric_arg(env, 0, &__bi_argcnt);
#line 203
        adjust_stack(env, __bi_argcnt + 1);
#line 203

#line 203

#line 203
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 203
		prog_trace(env, "dbmap %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? null : 0));;
#line 203

{
	const struct db_prop *prop = db_prop_lookup(dbname);
	
#line 206
dbmap_lookup(env,dbname,key,NULL,LOOKUP_TEST_ONLY | 
		         (((__bi_argcnt > 2) ? null : prop && prop->null)
			   ? LOOKUP_NULL_BYTE : 0));
#line 210
}

#line 211
	return;
#line 211
}

void
#line 213
bi_dbget(eval_environ_t env)
#line 213

#line 213

#line 213 "db.bi"
{
#line 213
	
#line 213

#line 213
long __bi_argcnt;
#line 213
char * MFL_DATASEG dbname;
#line 213
        char * MFL_DATASEG key;
#line 213
        char * MFL_DATASEG defval;
#line 213
        long  null;
#line 213
        
#line 213
get_string_arg(env, 1, &dbname);
#line 213
        get_string_arg(env, 2, &key);
#line 213
        get_string_arg(env, 3, &defval);
#line 213
        get_numeric_arg(env, 4, &null);
#line 213
        
#line 213
get_numeric_arg(env, 0, &__bi_argcnt);
#line 213
        adjust_stack(env, __bi_argcnt + 1);
#line 213

#line 213

#line 213
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 213
		prog_trace(env, "dbget %s %s %s %lu",dbname, key, ((__bi_argcnt > 2) ? defval : ""), ((__bi_argcnt > 3) ? null : 0));;

{
	const struct db_prop *prop = db_prop_lookup(dbname);
	
#line 217
dbmap_lookup(env,dbname,key,((__bi_argcnt > 2) ? defval : 0),((__bi_argcnt > 3) ? null : prop && prop->null)
		      ? LOOKUP_NULL_BYTE : 0);
#line 221
}

#line 222
	return;
#line 222
}

void
#line 224
bi_dbput(eval_environ_t env)
#line 224

#line 224

#line 224 "db.bi"
{
#line 224
	
#line 224

#line 224
long __bi_argcnt;
#line 224
char *  dbname;
#line 224
        char *  keystr;
#line 224
        char *  value;
#line 224
        long  null;
#line 224
        long  mode;
#line 224
        
#line 224
get_string_arg(env, 1, &dbname);
#line 224
        get_string_arg(env, 2, &keystr);
#line 224
        get_string_arg(env, 3, &value);
#line 224
        get_numeric_arg(env, 4, &null);
#line 224
        get_numeric_arg(env, 5, &mode);
#line 224
        
#line 224
get_numeric_arg(env, 0, &__bi_argcnt);
#line 224
        adjust_stack(env, __bi_argcnt + 1);
#line 224

#line 224

#line 224
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 224
		prog_trace(env, "dbput %s %s %s %lu %lu",dbname, keystr, value, ((__bi_argcnt > 3) ? null : 0), ((__bi_argcnt > 4) ? mode : 0));;

{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	const struct db_prop *prop = db_prop_lookup(dbname);
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_RDWR,
			((__bi_argcnt > 4) ? mode : (prop ? prop->mode : DEFAULT_DB_MODE)),
			NULL))
		(
#line 236
	env_throw_bi(env, mfe_dbfailure, "dbput", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror())
#line 236
);
#line 240
	memset(&key, 0, sizeof key);
	MF_DATUM_PTR(key) = keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 3) ? null : prop && prop->null))
		MF_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(contents) = value;
	MF_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mf_dbm_insert(&db, key, contents, 1);
	mf_dbm_close(&db);
		if (!(rc == 0))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_dbfailure, "dbput", _("failed to insert data to %s: %s %s: %s"),dbname,keystr,value,mf_dbm_strerror())
#line 252
)
#line 258
;
}

#line 260
	return;
#line 260
}

void
#line 262
bi_dbinsert(eval_environ_t env)
#line 262

#line 262

#line 262 "db.bi"
{
#line 262
	
#line 262

#line 262
long __bi_argcnt;
#line 262
char *  dbname;
#line 262
        char *  keystr;
#line 262
        char *  value;
#line 262
        long  replace;
#line 262
        long  null;
#line 262
        long  mode;
#line 262
        
#line 262
get_string_arg(env, 1, &dbname);
#line 262
        get_string_arg(env, 2, &keystr);
#line 262
        get_string_arg(env, 3, &value);
#line 262
        get_numeric_arg(env, 4, &replace);
#line 262
        get_numeric_arg(env, 5, &null);
#line 262
        get_numeric_arg(env, 6, &mode);
#line 262
        
#line 262
get_numeric_arg(env, 0, &__bi_argcnt);
#line 262
        adjust_stack(env, __bi_argcnt + 1);
#line 262

#line 262

#line 262
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 262
		prog_trace(env, "dbinsert %s %s %s %lu %lu %lu",dbname, keystr, value, ((__bi_argcnt > 3) ? replace : 0), ((__bi_argcnt > 4) ? null : 0), ((__bi_argcnt > 5) ? mode : 0));;

{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	const struct db_prop *prop = db_prop_lookup(dbname);
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_RDWR,
			((__bi_argcnt > 5) ? mode : (prop ? prop->mode : DEFAULT_DB_MODE)),
			NULL))
		(
#line 274
	env_throw_bi(env, mfe_dbfailure, "dbinsert", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror())
#line 274
);
#line 278
	memset(&key, 0, sizeof key);
	MF_DATUM_PTR(key) = keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 4) ? null : prop && prop->null))
		MF_DATUM_SIZE(key)++;

	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(contents) = value;
	MF_DATUM_SIZE(contents) = strlen(value) + 1;
	
	rc = mf_dbm_insert(&db, key, contents, ((__bi_argcnt > 3) ? replace : 0));
	mf_dbm_close(&db);
	if (rc == MU_ERR_EXISTS)
		(
#line 291
	env_throw_bi(env, mfe_exists, "dbinsert", _("record already exists"))
#line 291
);
	
		if (!(rc == 0))
#line 293
		(
#line 293
	env_throw_bi(env, mfe_dbfailure, "dbinsert", _("failed to insert data to %s: %s %s: %s"),dbname,keystr,value,mf_dbm_strerror())
#line 293
)
#line 299
;
}

#line 301
	return;
#line 301
}

void
#line 303
bi_dbdel(eval_environ_t env)
#line 303

#line 303

#line 303 "db.bi"
{
#line 303
	
#line 303

#line 303
long __bi_argcnt;
#line 303
char *  dbname;
#line 303
        char *  keystr;
#line 303
        long  null;
#line 303
        long  mode;
#line 303
        
#line 303
get_string_arg(env, 1, &dbname);
#line 303
        get_string_arg(env, 2, &keystr);
#line 303
        get_numeric_arg(env, 3, &null);
#line 303
        get_numeric_arg(env, 4, &mode);
#line 303
        
#line 303
get_numeric_arg(env, 0, &__bi_argcnt);
#line 303
        adjust_stack(env, __bi_argcnt + 1);
#line 303

#line 303

#line 303
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 303
		prog_trace(env, "dbdel %s %s %lu %lu",dbname, keystr, ((__bi_argcnt > 2) ? null : 0), ((__bi_argcnt > 3) ? mode : 0));;

{
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	int rc;
	const struct db_prop *prop = db_prop_lookup(dbname);
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_RDWR,
			((__bi_argcnt > 3) ? mode : (prop ? prop->mode : DEFAULT_DB_MODE)),
			NULL))
		(
#line 314
	env_throw_bi(env, mfe_dbfailure, "dbdel", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror())
#line 314
);
#line 318
	memset(&key, 0, sizeof key);
	MF_DATUM_PTR(key) = keystr;
	MF_DATUM_SIZE(key) = strlen(keystr);
	if (((__bi_argcnt > 2) ? null : prop && prop->null))
		MF_DATUM_SIZE(key)++;
	rc = mf_dbm_delete(&db, key);
	mf_dbm_close(&db);
		if (!(rc == 0))
#line 325
		(
#line 325
	env_throw_bi(env, mfe_dbfailure, "dbdel", _("failed to delete data `%s' from `%s': %s"),keystr,dbname,mf_dbm_strerror())
#line 325
)
#line 330
;
}

#line 332
	return;
#line 332
}


#define NUMDB 128

struct db_tab {
	int used;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
};

static void *
alloc_db_tab()
{
	return xcalloc(NUMDB, sizeof(struct db_tab));
}

static void
close_db_tab(struct db_tab *dbt)
{
	if (dbt->used) {
		mf_dbm_datum_free(&dbt->key);
		mf_dbm_close(&dbt->db);
		dbt->used = 0;
	}
}

static void
destroy_db_tab(void *data)
{
	int i;
	struct db_tab *db = data;
	for (i = 0; i < NUMDB; i++) 
		close_db_tab(db + i);
	free(db);
}


#line 369

#line 369
static int DBTAB_id;
#line 369 "db.bi"
;

static int
new_db_tab(struct db_tab *dbt)
{
	int i;
	for (i = 0; i < NUMDB; i++)
		if (!dbt[i].used) {
			dbt[i].used = 1;
			return i;
		}
	return -1;
}
			


void
#line 385
bi_dbfirst(eval_environ_t env)
#line 385

#line 385

#line 385 "db.bi"
{
#line 385
	
#line 385

#line 385

#line 385
char *  dbname;
#line 385
        
#line 385
get_string_arg(env, 0, &dbname);
#line 385
        
#line 385

#line 385
        adjust_stack(env, 1);
#line 385

#line 385

#line 385
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 385
		prog_trace(env, "dbfirst %s",dbname);;
#line 385

{
	int rc;
	int n;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id);
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	
	if (mf_dbm_open(dbname, &db, MU_STREAM_READ, 0, NULL))
		(
#line 394
	env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mf_dbm_open(%s) failed: %s"),dbname,mf_dbm_strerror())
#line 394
);
#line 398
	rc = mf_dbm_firstkey(&db, &key);
		if (!(rc == 0))
#line 399
		(
#line 399
	env_throw_bi(env, mfe_dbfailure, "dbfirst", _("mf_dbm_firstkey failed: %s"),mf_dbm_strerror())
#line 399
)
#line 401
;
	n = new_db_tab(dbt);
		if (!(n >= 0))
#line 403
		(
#line 403
	env_throw_bi(env, mfe_failure, "dbfirst", _("no more database entries available"))
#line 403
)
#line 405
;
	dbt += n;
	dbt->db = db;
	dbt->key = key;
	
#line 409
do {
#line 409
  push(env, (STKVAL) (n));
#line 409
  goto endlab;
#line 409
} while (0);
}
endlab:
#line 411
	return;
#line 411
}

void
#line 413
bi_dbnext(eval_environ_t env)
#line 413

#line 413

#line 413 "db.bi"
{
#line 413
	
#line 413

#line 413

#line 413
long  dn;
#line 413
        
#line 413
get_numeric_arg(env, 0, &dn);
#line 413
        
#line 413

#line 413
        adjust_stack(env, 1);
#line 413

#line 413

#line 413
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 413
		prog_trace(env, "dbnext %lu",dn);;
#line 413

{
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	MF_DBM_DATUM nextkey;
	int rc;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 419
		(
#line 419
	env_throw_bi(env, mfe_range, "dbnext", _("invalid database descriptor"))
#line 419
)
#line 421
;

	rc = mf_dbm_nextkey(&dbt->db, dbt->key, &nextkey);
	if (rc) {
		close_db_tab(dbt);
		
#line 426
do {
#line 426
  push(env, (STKVAL) (0));
#line 426
  goto endlab;
#line 426
} while (0);
	}
	mf_dbm_datum_free(&dbt->key);
	dbt->key = nextkey;
	
#line 430
do {
#line 430
  push(env, (STKVAL) (1));
#line 430
  goto endlab;
#line 430
} while (0);
}
endlab:
#line 432
	return;
#line 432
}

void
#line 434
bi_dbkey(eval_environ_t env)
#line 434

#line 434

#line 434 "db.bi"
{
#line 434
	
#line 434

#line 434

#line 434
long  dn;
#line 434
        
#line 434
get_numeric_arg(env, 0, &dn);
#line 434
        
#line 434

#line 434
        adjust_stack(env, 1);
#line 434

#line 434

#line 434
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 434
		prog_trace(env, "dbkey %lu",dn);;
#line 434

{
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 440
		(
#line 440
	env_throw_bi(env, mfe_range, "dbkey", _("invalid database descriptor"))
#line 440
)
#line 442
;
	
	len = MF_DATUM_SIZE(dbt->key);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MF_DATUM_PTR(dbt->key), len);
	s[len] = 0;
	
#line 448
do {
#line 448
  push(env, (STKVAL) (off));
#line 448
  goto endlab;
#line 448
} while (0);
}
endlab:
#line 450
	return;
#line 450
}

void
#line 452
bi_dbvalue(eval_environ_t env)
#line 452

#line 452

#line 452 "db.bi"
{
#line 452
	
#line 452

#line 452

#line 452
long  dn;
#line 452
        
#line 452
get_numeric_arg(env, 0, &dn);
#line 452
        
#line 452

#line 452
        adjust_stack(env, 1);
#line 452

#line 452

#line 452
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 452
		prog_trace(env, "dbvalue %lu",dn);;
#line 452

{
	int rc;
	size_t off, len;
	char *s;
	struct db_tab *dbt = env_get_builtin_priv(env,DBTAB_id) + dn;
	MF_DBM_DATUM contents;
	
		if (!(dn >= 0 && dn < NUMDB && dbt->used))
#line 460
		(
#line 460
	env_throw_bi(env, mfe_range, "dbvalue", _("invalid database descriptor"))
#line 460
)
#line 462
;

	memset(&contents, 0, sizeof contents);
	rc = mf_dbm_fetch(&dbt->db, dbt->key, &contents);
		if (!(rc == 0))
#line 466
		(
#line 466
	env_throw_bi(env, mfe_dbfailure, "dbvalue", _("key not found: %s"),mf_dbm_strerror())
#line 466
)
#line 469
;
	
	len = MF_DATUM_SIZE(contents);
	s = (char*) env_data_ref(env, (off = heap_reserve(env, len + 1)));
	memcpy(s, MF_DATUM_PTR(contents), len);
	s[len] = 0;
	mf_dbm_datum_free(&contents);
	
#line 476
do {
#line 476
  push(env, (STKVAL) (off));
#line 476
  goto endlab;
#line 476
} while (0);
}
endlab:
#line 478
	return;
#line 478
}


enum greylist_semantics
{
	greylist_traditional,
	greylist_ct
};

static enum greylist_semantics greylist_semantics = greylist_traditional;

/* #pragma greylist {traditional|gray|ct|con-tassios}*/
#line 490 "db.bi"

#line 490
static void _pragma_greylist (int argc, char **argv, const char *text)
#line 490

{
	if (strcmp(argv[1], "traditional") == 0
	    || strcmp(argv[1], "gray") == 0)
		greylist_semantics = greylist_traditional;
	else if (strcmp(argv[1], "ct") == 0
		 || strcmp(argv[1], "con-tassios") == 0)
		greylist_semantics = greylist_ct;
	else
		/* TRANSLATORS: Do not translate keywords:
		   traditional, gray, ct, con-tassios */
		parse_error(_("unknown semantics; allowed values are: "
			      "traditional (or gray) and "
			      "ct (or con-tassios)"));
}

/* FIXME: Duplicated in lib/cache.c */
static char *
format_timestr(time_t timestamp, char *timebuf, size_t bufsize)
{
	struct tm tm;
	gmtime_r(&timestamp, &tm);
	strftime(timebuf, bufsize, "%c", &tm);
	return timebuf;
}

static size_t greylist_seconds_left_loc
#line 516 "db.bi"
;

/* The traditional (aka gray's) greylist implementation: the greylist
   database keeps the time the greylisting was activated.
 */
static int
do_greylist_traditional(eval_environ_t env, char *email, long interval)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 533
		(
#line 533
	env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
#line 533
)
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp, diff;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 545
		(
#line 545
	env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 545
)
#line 548
;
		
		timestamp = *(time_t*) MF_DATUM_PTR(contents);
		diff = now - timestamp;

		if (mu_debug_level_p(debug_handle, MU_DEBUG_TRACE5)) {
			char timebuf[32];
			mu_debug_log("%s entered greylist database on %s, "
				     "%ld seconds ago",
				     email,
				     format_timestr(timestamp, timebuf,
						    sizeof timebuf),
				     (long) diff);
		}

		if (diff < interval) {
			diff = interval - diff;

			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			
#line 568

#line 568
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s still greylisted (for %lu sec.)",
			          email,
			          (unsigned long) diff));
#line 572
			rc = 1;
		} else if (diff > greylist_format->expire_interval) {
			
#line 574

#line 574
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylist record for %s expired", email));
#line 576
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
			if (!readonly) {
				memcpy(MF_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mf_dbm_insert(&db, key, contents, 1))
					mu_error(_("cannot insert datum `%-.*s' in "
						   "greylist database %s: %s"),
			                         MF_DATUM_SIZE(key),
						 (char*)MF_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mf_dbm_strerror());
			} else
				
#line 588

#line 588
mu_debug(debug_handle, MU_DEBUG_TRACE6,("database opened in readonly mode: "
			  	          "not updating"));
#line 591
			rc = 1;
		} else {
			
#line 593

#line 593
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s finished greylisting period", email));
#line 595
			rc = 0;
		}
		mf_dbm_datum_free(&contents);
	} else if (!readonly) {
		
#line 599

#line 599
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylisting %s", email));
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		MF_DATUM_PTR(contents) = (void*)&now;
		MF_DATUM_SIZE(contents) = sizeof now;
		if (mf_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MF_DATUM_SIZE(key), (char*)MF_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mf_dbm_strerror());
		rc = 1;
	} else
		rc = 0;

	mf_dbm_close(&db);

	return rc;
}

/* Implementation of the is_greylisted predicate has no sense for 
   traditional greylist databases, because greylisting interval is
   not known beforehand.
   FIXME: keep the reference below up to date.
 */
static int
is_greylisted_traditional(eval_environ_t env, char *email)
{
	(
#line 626
	env_throw_bi(env, mfe_failure, NULL, _("is_greylisted is not implemented for traditional greylist databases; "
		   "see documentation, chapter %s %s for more info"),"4.12.1.23","Greylisting functions")
#line 626
);
#line 630
	return 0;
}

/* New greylist implementation (by Con Tassios): the database keeps
   the time the greylisting period is set to expire (`interval' seconds
   from now)
*/
static int
do_greylist_ct(eval_environ_t env, char *email, long interval)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
        	if (!(rc == 0))
#line 649
		(
#line 649
	env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
#line 649
)
;
	
	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email)+1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 661
		(
#line 661
	env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 661
)
#line 664
;
		
		timestamp = *(time_t*) MF_DATUM_PTR(contents);

		if (now < timestamp) {
			time_t diff = timestamp - now;
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (diff);
			
			
#line 672

#line 672
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s still greylisted (for %lu sec.)",
			          email,
                                  (unsigned long) diff));
#line 676
			rc = 1;
		} else if (now - timestamp >
			   greylist_format->expire_interval) {
			
#line 679

#line 679
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylist record for %s expired", email));
#line 681
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
			if (!readonly) {
				now += interval;
				memcpy(MF_DATUM_PTR(contents),
				       &now, sizeof now);
				if (mf_dbm_insert(&db, key, contents, 1))
					mu_error(_("Cannot insert datum "
						   "`%-.*s' in greylist "
						   "database %s: %s"),
			                         MF_DATUM_SIZE(key),
						 (char*)MF_DATUM_PTR(key),
						 greylist_format->dbname,
	                                         mf_dbm_strerror());
			} else
				
#line 695

#line 695
mu_debug(debug_handle, MU_DEBUG_TRACE6,("database opened in readonly mode: "
				          "not updating"));
#line 698
			rc = 1;
		} else {
			
#line 700

#line 700
mu_debug(debug_handle, MU_DEBUG_TRACE6,("%s finished greylisting period", email));
#line 702
			rc = 0;
		}
		mf_dbm_datum_free(&contents);
	} else if (!readonly) {
		
#line 706

#line 706
mu_debug(debug_handle, MU_DEBUG_TRACE6,("greylisting %s", email));
		*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (interval);
		now += interval;
		MF_DATUM_PTR(contents) = (void*)&now;
		MF_DATUM_SIZE(contents) = sizeof now;
		if (mf_dbm_insert(&db, key, contents, 1))
			mu_error(_("Cannot insert datum `%-.*s' in greylist "
				   "database %s: %s"),
		                 MF_DATUM_SIZE(key), (char*)MF_DATUM_PTR(key),
				 greylist_format->dbname,
	                         mf_dbm_strerror());
		rc = 1;
	} else
		rc = 0;
	
	mf_dbm_close(&db);
	
	return rc;
}

/* The `is_greylisted' predicate for new databases */
static int
is_greylisted_ct(eval_environ_t env, char *email)
{
	int rc;
	MF_DBM_FILE db;
	MF_DBM_DATUM key;
	MF_DBM_DATUM contents;
	int readonly;
	time_t now;

	rc = mf_dbm_open(greylist_format->dbname, &db, MU_STREAM_RDWR, 0600,
			 &readonly);
		if (!(rc == 0))
#line 739
		(
#line 739
	env_throw_bi(env, mfe_dbfailure, NULL, _("mf_dbm_open(%s) failed: %s"),greylist_format->dbname,mf_dbm_strerror())
#line 739
)
;

	memset(&key, 0, sizeof key);
	memset(&contents, 0, sizeof contents);
	MF_DATUM_PTR(key) = email;
	MF_DATUM_SIZE(key) = strlen(email) + 1;

	time(&now);
	if (mf_dbm_fetch(&db, key, &contents) == 0) {
		time_t timestamp;

			if (!(MF_DATUM_SIZE(contents) == sizeof timestamp))
#line 751
		(
#line 751
	env_throw_bi(env, mfe_dbfailure, NULL, _("greylist database %s has wrong data size"),greylist_format->dbname)
#line 751
)
#line 754
;
                
		timestamp = *(time_t*) MF_DATUM_PTR(contents);
                
		rc = timestamp > now;
                if (rc)
			*env_data_ref(env, greylist_seconds_left_loc) = (STKVAL) (timestamp - now);

		mf_dbm_datum_free(&contents);
	} else  
		rc = 0;

	mf_dbm_close(&db);

	return rc;
}

struct greylist_class {
	int (*gl_fun)(eval_environ_t, char *, long);
	int (*gl_pred)(eval_environ_t, char *);
};

struct greylist_class greylist_class[] = {
	{ do_greylist_traditional, is_greylisted_traditional },
	{ do_greylist_ct, is_greylisted_ct }
};

/* greylist(key, interval)

   Returns true if the key is greylisted, false if it's OK to
   deliver mail.
 */
void
#line 786
bi_greylist(eval_environ_t env)
#line 786

#line 786

#line 786 "db.bi"
{
#line 786
	
#line 786

#line 786

#line 786
char *  email;
#line 786
        long  interval;
#line 786
        
#line 786
get_string_arg(env, 0, &email);
#line 786
        get_numeric_arg(env, 1, &interval);
#line 786
        
#line 786

#line 786
        adjust_stack(env, 2);
#line 786

#line 786

#line 786
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 786
		prog_trace(env, "greylist %s %lu",email, interval);;
#line 786

{
	
#line 788
do {
#line 788
  push(env, (STKVAL) (greylist_class[greylist_semantics].gl_fun(env, email,
#line 788
							    interval)));
#line 788
  goto endlab;
#line 788
} while (0);
#line 790
}
endlab:
#line 791
	return;
#line 791
}

/* is_greylisted(key)
   
   Returns true if the key is greylisted, otherwise false
   
*/
void
#line 798
bi_is_greylisted(eval_environ_t env)
#line 798

#line 798

#line 798 "db.bi"
{
#line 798
	
#line 798

#line 798

#line 798
char *  email;
#line 798
        
#line 798
get_string_arg(env, 0, &email);
#line 798
        
#line 798

#line 798
        adjust_stack(env, 1);
#line 798

#line 798

#line 798
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 798
		prog_trace(env, "is_greylisted %s",email);;
#line 798

{
	
#line 800
do {
#line 800
  push(env, (STKVAL) (greylist_class[greylist_semantics].gl_pred(env, email)));
#line 800
  goto endlab;
#line 800
} while (0);
}
endlab:
#line 802
	return;
#line 802
}

void
#line 804
bi_db_name(eval_environ_t env)
#line 804

#line 804

#line 804 "db.bi"
{
#line 804
	
#line 804

#line 804

#line 804
char * MFL_DATASEG fmtid;
#line 804
        
#line 804
get_string_arg(env, 0, &fmtid);
#line 804
        
#line 804

#line 804
        adjust_stack(env, 1);
#line 804

#line 804

#line 804
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 804
		prog_trace(env, "db_name %s",fmtid);;
#line 804

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 807
		(
#line 807
	env_throw_bi(env, mfe_not_found, "db_name", _("no such db format: %s"),fmtid)
#line 807
)
#line 809
;
	do {pushs(env, fmt->dbname);
#line 810
goto endlab;
#line 810
} while (0);
}
endlab:
#line 812
	return;
#line 812
}

void
#line 814
bi_db_get_active(eval_environ_t env)
#line 814

#line 814

#line 814 "db.bi"
{
#line 814
	
#line 814

#line 814

#line 814
char *  fmtid;
#line 814
        
#line 814
get_string_arg(env, 0, &fmtid);
#line 814
        
#line 814

#line 814
        adjust_stack(env, 1);
#line 814

#line 814

#line 814
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 814
		prog_trace(env, "db_get_active %s",fmtid);;
#line 814

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 817
		(
#line 817
	env_throw_bi(env, mfe_not_found, "db_get_active", _("no such db format: %s"),fmtid)
#line 817
)
#line 819
;
	
#line 820
do {
#line 820
  push(env, (STKVAL) (fmt->enabled));
#line 820
  goto endlab;
#line 820
} while (0);
}
endlab:
#line 822
	return;
#line 822
}

void
#line 824
bi_db_set_active(eval_environ_t env)
#line 824

#line 824

#line 824 "db.bi"
{
#line 824
	
#line 824

#line 824

#line 824
char *  fmtid;
#line 824
        long  active;
#line 824
        
#line 824
get_string_arg(env, 0, &fmtid);
#line 824
        get_numeric_arg(env, 1, &active);
#line 824
        
#line 824

#line 824
        adjust_stack(env, 2);
#line 824

#line 824

#line 824
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 824
		prog_trace(env, "db_set_active %s %lu",fmtid, active);;
#line 824

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 827
		(
#line 827
	env_throw_bi(env, mfe_not_found, "db_set_active", _("no such db format: %s"),fmtid)
#line 827
)
#line 829
;
	fmt->enabled = active;
}

#line 832
	return;
#line 832
}

void
#line 834
bi_db_expire_interval(eval_environ_t env)
#line 834

#line 834

#line 834 "db.bi"
{
#line 834
	
#line 834

#line 834

#line 834
char *  fmtid;
#line 834
        
#line 834
get_string_arg(env, 0, &fmtid);
#line 834
        
#line 834

#line 834
        adjust_stack(env, 1);
#line 834

#line 834

#line 834
	if (builtin_module_trace(BUILTIN_IDX_db))
#line 834
		prog_trace(env, "db_expire_interval %s",fmtid);;
#line 834

{
	struct db_format *fmt = db_format_lookup(fmtid);
		if (!(fmt != NULL))
#line 837
		(
#line 837
	env_throw_bi(env, mfe_not_found, "db_expire_interval", _("no such db format: %s"),fmtid)
#line 837
)
#line 839
;
	
#line 840
do {
#line 840
  push(env, (STKVAL) (fmt->expire_interval));
#line 840
  goto endlab;
#line 840
} while (0);
}
endlab:
#line 842
	return;
#line 842
}


#line 844
void
#line 844
db_init_builtin()
#line 844
{
#line 844
		debug_handle = mu_debug_register_category("bi_db");
#line 844

#line 844
	#line 70 "db.bi"

#line 70
install_pragma("dbprop", 3, 4, _pragma_dbprop);
#line 203 "db.bi"
va_builtin_install_ex("dbmap", bi_dbmap, 0, dtype_number, 3, 1, 0|0, dtype_string, dtype_string, dtype_number);
#line 213 "db.bi"
va_builtin_install_ex("dbget", bi_dbget, 0, dtype_string, 4, 2, 0|0, dtype_string, dtype_string, dtype_string, dtype_number);
#line 224 "db.bi"
va_builtin_install_ex("dbput", bi_dbput, 0, dtype_unspecified, 5, 2, 0|0, dtype_string, dtype_string, dtype_string, dtype_number, dtype_number);
#line 262 "db.bi"
va_builtin_install_ex("dbinsert", bi_dbinsert, 0, dtype_unspecified, 6, 3, 0|0, dtype_string, dtype_string, dtype_string, dtype_number, dtype_number, dtype_number);
#line 303 "db.bi"
va_builtin_install_ex("dbdel", bi_dbdel, 0, dtype_unspecified, 4, 2, 0|0, dtype_string, dtype_string, dtype_number, dtype_number);
#line 369 "db.bi"
DBTAB_id = builtin_priv_register(alloc_db_tab, destroy_db_tab,
#line 369
NULL);
#line 385 "db.bi"
va_builtin_install_ex("dbfirst", bi_dbfirst, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 413 "db.bi"
va_builtin_install_ex("dbnext", bi_dbnext, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 434 "db.bi"
va_builtin_install_ex("dbkey", bi_dbkey, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 452 "db.bi"
va_builtin_install_ex("dbvalue", bi_dbvalue, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 490 "db.bi"

#line 490
install_pragma("greylist", 2, 2, _pragma_greylist);
#line 516 "db.bi"
	builtin_variable_install("greylist_seconds_left", dtype_number, SYM_VOLATILE, &greylist_seconds_left_loc);
#line 786 "db.bi"
va_builtin_install_ex("greylist", bi_greylist, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_number);
#line 798 "db.bi"
va_builtin_install_ex("is_greylisted", bi_is_greylisted, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 804 "db.bi"
va_builtin_install_ex("db_name", bi_db_name, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 814 "db.bi"
va_builtin_install_ex("db_get_active", bi_db_get_active, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 824 "db.bi"
va_builtin_install_ex("db_set_active", bi_db_set_active, 0, dtype_unspecified, 2, 0, 0|0, dtype_string, dtype_number);
#line 834 "db.bi"
va_builtin_install_ex("db_expire_interval", bi_db_expire_interval, 0, dtype_number, 1, 0, 0|0, dtype_string);

#line 844 "db.bi"
	
#line 844
}
#line 844 "db.bi"

#line 844


#line 736 "../../src/builtin/snarf.m4"

#line 736

